slotOutputTables = {};

source(MultiOverlayV3.modDir.."slotsOutputTables/fillTypesEnableDisable.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/fillTypesAmount.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/fillTypesAmountPrice.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/sellingStationsSimple.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/buyingStationsSimple.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/animals.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/windturbinen.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/greenhouses.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/beehivehouses.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/solarcollectoren.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/heatingplants.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/bgas.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/missions.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/bunkersilos.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/feedmixers.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/gcfactorys.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/objectstorages.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/filltypemovers.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/storages.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/consolenCmds.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/farmlands.lua");
source(MultiOverlayV3.modDir.."slotsOutputTables/actionOpenCloseCmds.lua");
--source(MultiOverlayV3.modDir.."slotsOutputTables/fieldinfos.lua");


function slotOutputTables.returnLineClickSortByButtons(...)
	if ... ~= nil then		
		local args = ...;
		if args.line ~= nil and args.whereClick ~= nil and moSetGetOverlays.slot[args.whereClick] ~= nil then
			local slotTable = moSetGetOverlays.slot[args.whereClick];
			if args.line == 2 then
				if slotTable.setting.sortOn then
					slotTable.setting.sortOn = false;
				else 
					slotTable.setting.sortOn = true;
				end
			end;
		end;
	end;
end;

function slotOutputTables.returnLineClickSortByNames(...)
	if ... ~= nil then		
		local args = ...;
		if args.line ~= nil and args.whereClick ~= nil and moSetGetOverlays.slot[args.whereClick] ~= nil then
			local slotTable = moSetGetOverlays.slot[args.whereClick];
			if slotTable.setting.sortOn and args.line > 2 then
				if slotTable.setting.sortNames[args.line-2] ~= nil then
					if args.line-2 == slotTable.setting.sortInt then
						slotTable.setting.sortInt = 1;
						slotTable.setting.sortBy = slotTable.setting.sortNames[1];
					else
						slotTable.setting.sortInt = args.line-2;
						slotTable.setting.sortBy = slotTable.setting.sortNames[args.line-2];						
					end;
				end;
			end;
		end;
	end;
end;	

function slotOutputTables:loadSlotOutputCmd(whichSLOT)
	local playerFarmId = g_currentMission.player.farmId;
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	local sortBy = moSetGetOverlays.slot[whichSubSLOT].setting.sortBy;
	slotOutputTables.cmd = {};
	slotOutputTables.oldCmd = {};	
	for cmdTable=1, #MultiOverlayV3.cmdTable do
		for cmd=1, #MultiOverlayV3.cmdTable[cmdTable].cmd do
			--local actionOpenCloseCmd = string.find(MultiOverlayV3.cmdTable[cmdTable].cmd[cmd].name, "openCloseSlot") or string.find(MultiOverlayV3.cmdTable[cmdTable].cmd[cmd].name, "openClosePda");
			if MultiOverlayV3.cmdTable[cmdTable].cmd[cmd].typ == "output_" then
				if moSetGetOverlays.slot[whichSubSLOT].setting.sortInt == 1 then
					slotOutputTables.cmd[#slotOutputTables.cmd+1] = {displayName=MultiOverlayV3.cmdTable[cmdTable].cmd[cmd].displayName, cmdTable=cmdTable,cmdPos=cmd};
				else
					local sortByNames = moSetGetOverlays.slot[whichSubSLOT].setting.sortNames[moSetGetOverlays.slot[whichSubSLOT].setting.sortInt];
					if MultiOverlayV3.cmdTable[cmdTable].cmd[cmd].sortBy == sortByNames then
						slotOutputTables.cmd[#slotOutputTables.cmd+1] = {displayName=MultiOverlayV3.cmdTable[cmdTable].cmd[cmd].displayName, cmdTable=cmdTable, cmdPos=cmd};
					end;
				end;				
			end;
		end;
	end;	
	function comp(w1,w2)			
		if w1.displayName < w2.displayName then
			return true;
		end;			
	end;
	table.sort(slotOutputTables.cmd, comp);
	--old Cmds or other Maps Cmds
	for oldCmd=1, #moSetGetOverlays.slot[whichSubSLOT].cmd do
		if moSetGetOverlays.slot[whichSubSLOT].cmd[oldCmd] ~= nil then
			local oldCmdTable = moSetGetOverlays.slot[whichSubSLOT].cmd[oldCmd];
			local isCmdReady = moSetGetCmd:cmdFromReady(nil, oldCmdTable.name, oldCmdTable.from, oldCmdTable.fromRealName, true, MultiOverlayV3.moduleCmdTable);
			if isCmdReady == nil then
				slotOutputTables.oldCmd[#slotOutputTables.oldCmd+1] = {displayName="OldCmd", oldName=oldCmdTable.name, cmdPos=oldCmd};
			end;
		end;
	end;
	--old Cmds or other Maps Cmds
	
	function isCmdSelect(cmdTable, cmdPos)
		if cmdTable ~= nil and cmdPos ~= nil then
			for cmd=1, #moSetGetOverlays.slot[whichSubSLOT].cmd do
				if cmdTable.cmd[cmdPos] ~= nil and moSetGetOverlays.slot[whichSubSLOT].cmd[cmd] ~= nil then
					if cmdTable.cmd[cmdPos].name == moSetGetOverlays.slot[whichSubSLOT].cmd[cmd].name and cmdTable.luaName == moSetGetOverlays.slot[whichSubSLOT].cmd[cmd].from and cmdTable.realName == moSetGetOverlays.slot[whichSubSLOT].cmd[cmd].fromRealName then return true;end;
				end;
			end;
		end;
		return false;
	end;	
	local lineTable = {};		
	lineTable[#lineTable+1] = {};
	local isLineTable = lineTable[#lineTable];	
	isLineTable.isSelect = true;	
	isLineTable.txt = {};	
	isLineTable.txt[1] = {color=moColors:getColor("khaki", true), txt="Select Output Cmd", bold=true, txtPos=1};	
	isLineTable.lineClickHelp = true;
	isLineTable.lineClickHelpCallback = slotOutputTables.returnOutputCmdLineHelpIconClick
	isLineTable.helpTxt = "Click Cmd Right for Map Coordinates(is O = 1)";
		
	lineTable[#lineTable+1] = {};
	isLineTable = lineTable[#lineTable];
	isLineTable.isSelect = true;		
	isLineTable.txt = {};	
	isLineTable.txt[1] = {color=moColors:getColor("khaki", true), txt="SortBy ".. tostring(sortBy), bold=true, txtPos=0, clickCallback=slotOutputTables.returnLineClickSortByButtons};
	isLineTable.txt[1].settingsButtonL = {"buttonLeft", moColors.intern["green"], slotOutputTables.returnLineClickSortByButtons};
			
	local cmdFoundOtherSlots = moSetGetCmd:getAllSetSlotCmd();
	if not moSetGetOverlays.slot[whichSubSLOT].setting.sortOn then
		lineTable[#lineTable+1] = {};
		isLineTable = lineTable[#lineTable];
		isLineTable.isSelect = true;		
		isLineTable.txt = {};		
		isLineTable.txt[1] = {width=5,color=moColors:getColor("khaki", true), txt="S", bold=true};
		isLineTable.txt[2] = {width=90,color=moColors:getColor("khaki", true), txt="CMDs", bold=true, txtPos=1};
		isLineTable.txt[3] = {width=5,color=moColors:getColor("khaki", true), txt="O", bold=true};		
		isLineTable.lineClickHelp = true;
		isLineTable.lineClickHelpCallback = slotOutputTables.returnOutputCmdLineHelpIconClick
		isLineTable.helpTxt = "O <--Found Objects for Cmd, 1,2 or ... etc.\nS <--Cmd Select other Slot";		
		
		local sortLineTable = {};
		local sortLineTableNoSelect = {};
		for cmd=1, #slotOutputTables.cmd do
			local getOrginalCmd = MultiOverlayV3.cmdTable[slotOutputTables.cmd[cmd].cmdTable].cmd[slotOutputTables.cmd[cmd].cmdPos];
			local isSelect = isCmdSelect(MultiOverlayV3.cmdTable[slotOutputTables.cmd[cmd].cmdTable], slotOutputTables.cmd[cmd].cmdPos);
			if not isSelect then
				sortLineTableNoSelect[#sortLineTableNoSelect+1] = {};
				isLineTable = sortLineTableNoSelect[#sortLineTableNoSelect];
			else
				sortLineTable[#sortLineTable+1] = {};
				isLineTable = sortLineTable[#sortLineTable];		
			end;
			isLineTable.lineClickHelp = true;
			isLineTable.lineClickHelpCallback = slotOutputTables.returnOutputCmdLineHelpIconClick
			isLineTable.helpTxt = getOrginalCmd.infoTxt.. "\n".. getOrginalCmd.helpTxt;
			isLineTable.isSelect = isSelect;			
			local nodeIds = nil;
			local isNearObject = nil;
			local farmId = 0;
			if getOrginalCmd.ownValues ~= nil and getOrginalCmd.ownValues[2] ~= nil and #getOrginalCmd.ownValues[2] > 0 then
				nodeIds = getOrginalCmd.ownValues[2];				
				if #nodeIds == 1 then 
					isNearObject = moModule:nearPlayerPositionObjectId(nodeIds[1], moModule.values.cmdObjectDistance);					
				else
					--unknown more objects
				end;
				if moSetGetOverlays.slot[whichSubSLOT].typ == 2 then
					for a=1, #nodeIds do
						local x, y, z = getWorldTranslation(nodeIds[a])
						local txt = slotOutputTables.cmd[cmd].displayName;
						local distance = calcDistanceFrom(nodeIds[a], getCamera());
						if x ~= nil and y ~= nil and z ~= nil and (x~=0 and y~=0 and z~=0) and distance < 40 then
							Utils.renderTextAtWorldPosition(x, y+2, z, txt, getCorrectTextSize(0.02), 0.02, moColors:getColor("ls15", true));
						end;
					end;
				end;
			end;
			if getOrginalCmd.ownValues ~= nil and getOrginalCmd.ownValues[3] ~= nil and #getOrginalCmd.ownValues[3] > 0 then
				ids = getOrginalCmd.ownValues[3];
				if #ids == 1 then					
					local object = NetworkUtil.getObject(ids[1]);
					if object ~= nil and object.ownerFarmId ~= nil and object.ownerFarmId ~= 0 then
						farmId = Utils.getNoNil(object.ownerFarmId, 0);
					end;
				else
					--unknown more objects
				end;
			end;
			isLineTable.cmdTable = slotOutputTables.cmd[cmd].cmdTable;
			isLineTable.cmdPos = slotOutputTables.cmd[cmd].cmdPos;
			--isLineTable.multiple = slotOutputTables.cmd[cmd].multiple;
			isLineTable.orginalCmdTable = MultiOverlayV3.cmdTable[slotOutputTables.cmd[cmd].cmdTable];
			isLineTable.orginalCmd = getOrginalCmd;
			isLineTable.txt = {};			
			
			isLineTable.txt[1] = {};
			isLineTable.txt[1].width = 5;	--width prozent			
			if isSelect then isLineTable.txt[1].color = moColors:getColor("green", true);end;			
			if cmdFoundOtherSlots[getOrginalCmd.name] ~= nil and not isSelect or (isSelect and cmdFoundOtherSlots[getOrginalCmd.name].isFound > 1)then 
				isLineTable.txt[1].txt = tostring(cmdFoundOtherSlots[getOrginalCmd.name].isFound);
			else
				isLineTable.txt[1].txt = "";
			end;
			
			isLineTable.txt[2] = {};
			isLineTable.txt[2].width = 90;	--width prozent			
			if nodeIds ~= nil then isLineTable.nodeIds = nodeIds;end; --multiple object cmd			
			isLineTable.txt[2].txt = slotOutputTables.cmd[cmd].displayName;
			isLineTable.sortBy = slotOutputTables.cmd[cmd].displayName;
			if isNearObject ~= nil and isNearObject then isLineTable.txt[2].txt = ">>".. isLineTable.txt[2].txt;isLineTable.txt[2].color = moColors:getColor("ls15Disabled", true);					
			elseif isSelect then isLineTable.txt[2].color = moColors:getColor("green", true);end;
			--if not isSelect and farmId ~= 0 and farmId == playerFarmId then isLineTable.txt[1].color = moColors:getColor("ls15Disabled", true);end;					
			isLineTable.txt[2].farmId = farmId;
			isLineTable.txt[2].clickCallback = slotOutputTables.returnSelectCmdLineClick;
			isLineTable.txt[3] = {};
			isLineTable.txt[3].width = 5;	--width prozent			
			if nodeIds ~= nil then isLineTable.txt[3].txt = tostring(#nodeIds);else isLineTable.txt[3].txt = "1";end; --multiple object cmd
			if isSelect then isLineTable.txt[3].color = moColors:getColor("green", true);end;
						
		end;
		function comp1(w1,w2)			
			if w1.sortBy < w2.sortBy then
				return true;
			end;			
		end;
		table.sort(sortLineTable, comp1);
		table.sort(sortLineTableNoSelect, comp1);		
		if #slotOutputTables.oldCmd > 0 then
			for cmd=1, #slotOutputTables.oldCmd do
				sortLineTableNoSelect[#sortLineTableNoSelect+1] = {};
				isLineTable = sortLineTableNoSelect[#sortLineTableNoSelect];
				isLineTable.lineClickHelp = true;
				isLineTable.lineClickHelpCallback = slotOutputTables.returnOutputCmdLineHelpIconClick
				isLineTable.helpTxt = "Cmd is other Object(or Maps) or not exists this map";
				isLineTable.isSelect = true;
				isLineTable.cmdTable = 0;
				isLineTable.cmdPos = slotOutputTables.oldCmd[cmd].cmdPos;
				isLineTable.txt = {};		
				isLineTable.txt[1] = {};				
				isLineTable.txt[1].width = 100;	--width prozent			
				isLineTable.txt[1].txt = slotOutputTables.oldCmd[cmd].displayName .. " (".. tostring(slotOutputTables.oldCmd[cmd].oldName).. ")";			
				isLineTable.txt[1].bold = false;
				isLineTable.txt[1].color = moColors:getColor("green", true);
				isLineTable.txt[1].clickCallback = slotOutputTables.returnSelectOldCmdLineClick;				
			end;
		end;
		for a=1, #sortLineTableNoSelect do
			if sortLineTableNoSelect[a] ~= nil then
				table.insert(sortLineTable, sortLineTableNoSelect[a]);
			end;
		end;
		moSetGetOverlays.slot[whichSubSLOT].setting.output = sortLineTable;
		table.insert(moSetGetOverlays.slot[whichSubSLOT].setting.output, 1, lineTable[1]);
		table.insert(moSetGetOverlays.slot[whichSubSLOT].setting.output, 2, lineTable[2]);
		table.insert(moSetGetOverlays.slot[whichSubSLOT].setting.output, 3, lineTable[3]);
	elseif moSetGetOverlays.slot[whichSubSLOT].setting.sortOn then		
		for sortInt=1, #moSetGetOverlays.slot[whichSubSLOT].setting.sortNames do
			lineTable[#lineTable+1] = {};
			isLineTable = lineTable[#lineTable];
			isLineTable.isSelect = moSetGetOverlays.slot[whichSubSLOT].setting.sortInt == sortInt;
			isLineTable.txt = {};		
			isLineTable.txt[1] = {};
			isLineTable.txt[1].width = 100;	--width prozent			
			isLineTable.txt[1].txt = moSetGetOverlays.slot[whichSubSLOT].setting.sortNames[sortInt];			
			isLineTable.txt[1].bold = true;		
			isLineTable.txt[1].clickCallback = slotOutputTables.returnLineClickSortByNames;
			if isLineTable.isSelect then isLineTable.txt[1].color = moColors:getColor("green", true);end;			
		end;
		moSetGetOverlays.slot[whichSubSLOT].setting.output = lineTable;
	end;
end;

function slotOutputTables.returnSelectOldCmdLineClick(...)
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.line > 2 and args.whereClick ~= nil and moSetGetOverlays.slot[args.whereClick] ~= nil then
			if not moModule.values.canDeleteOldCmd then
				moSetGetOverlays.infoHelpBox.info.lsTimer = 3000;
				moSetGetOverlays.infoHelpBox.info.txt = "Can not OldCmd delete or ....\ndelete cmd over OldObject(Map)\nor set CanDeleteOldCmd On(Module(Moh) Settings)";
			else
				local lineTable = moSetGetOverlays.slot[args.whereClick].setting.output[args.line];
				moSetGetOverlays.slot[args.whereClick].cmd[lineTable.cmdPos] = nil;
				moSetGetOverlays.slot[args.whereClick].save = false;
			end;
		end;
	end;	
end;

function slotOutputTables.returnSelectCmdLineClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.line > 2 and args.whereClick ~= nil and moSetGetOverlays.slot[args.whereClick] ~= nil and args.mouseClickType == "mouseButtonLeft" then
			local lineTable = moSetGetOverlays.slot[args.whereClick].setting.output[args.line];
			local getOrginalCmdTable = MultiOverlayV3.cmdTable[lineTable.cmdTable];
			local getOrginalCmd = MultiOverlayV3.cmdTable[lineTable.cmdTable].cmd[lineTable.cmdPos];
			local slotTableCmd = moSetGetOverlays.slot[args.whereClick].cmd;
			if #slotTableCmd == 0 then
				slotTableCmd[1] = {name=getOrginalCmd.name, from=getOrginalCmdTable.luaName, fromRealName=getOrginalCmdTable.realName};
				moSetGetOverlays.slot[args.whereClick].save = false;
				return;
			end;
			if lineTable.isSelect then				
				local deleteCmd = {};
				for cmd=1, #slotTableCmd do
					if slotTableCmd[cmd].name == getOrginalCmd.name and slotTableCmd[cmd].from == getOrginalCmdTable.luaName and slotTableCmd[cmd].fromRealName == getOrginalCmdTable.realName then
						table.insert(deleteCmd, cmd);
					end;
				end;
				if #deleteCmd > 0 then
					for _, index in pairs (deleteCmd) do				
						table.remove(slotTableCmd, index);
					end;
				end;
				moSetGetOverlays.slot[args.whereClick].save = false;
				return;
			end;
			if getOrginalCmd.multiple then
				slotTableCmd[#slotTableCmd+1] = {name=getOrginalCmd.name, from=getOrginalCmdTable.luaName, fromRealName=getOrginalCmdTable.realName};
				moSetGetOverlays.slot[args.whereClick].save = false;
			else
				moSetGetOverlays.infoHelpBox.info.lsTimer = 3000;
				moSetGetOverlays.infoHelpBox.info.txt = "Output Cmd is not multiple (set alone)";
			end;
		elseif args.line ~= nil and args.line > 2 and args.whereClick ~= nil and moSetGetOverlays.slot[args.whereClick] ~= nil and args.mouseClickType == "mouseButtonRight" then
			local lineTable = moSetGetOverlays.slot[args.whereClick].setting.output[args.line];
			if lineTable.nodeIds ~= nil then				
				if #lineTable.nodeIds > 1 then local foundMore=true;end;				
				local x, _, z = getWorldTranslation(lineTable.nodeIds[1]);
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;
		end;
	end;
end;

function slotOutputTables.returnOutputCmdLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.whereClick ~= nil and moSetGetOverlays.slot[args.whereClick] ~= nil then			
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(moSetGetOverlays.slot[args.whereClick].setting.output[args.line].helpTxt);			
		end;
	end;
end;

